# ElementUtil API

## [Base Methods](base-methods.md)

- [getElement](base-methods.md#getelement): Get a single element.
- [getElements](base-methods.md#getelements): Get elements as NodeList.
- [getElementsAsArray](base-methods.md#getelementsasarray): Get elements as array of HTMLElement.
- [removeElements](base-methods.md#removeelements): Remove elements by selector.
- [toNodeList](base-methods.md#tonodelist): Convert a single Element to NodeList.
- [nodeListToArray](base-methods.md#nodelisttoarray): Convert NodeList to Array.
- [findAncestor](base-methods.md#findancestor): Find ancestor from element.

## [Util Methods](util-methods.md)

- [addListener](util-methods.md#addlistener): Add event listener on selector.
- [addOuterListener](util-methods.md#addouterlistener): Add listener for the event that occurs outer of the target element.
- [wrap](util-methods.md#wrap): Wrap elements by div.wrapper, one by one.
- [wrapAll](util-methods.md#wrapall): Wrap all elements inside to div.wrapper.
- [submitConfirm](util-methods.md#submitconfirm): Add confirm message on 'submit' event.
- [addClass](util-methods.md#addclass): Add class to an element.
- [removeClass](util-methods.md#removeclass): Remove class from an element.
- [toggleClass](util-methods.md#toggleclass): Toggling class.
- [hide](util-methods.md#hide): Hide an element. use style `display: none;`
- [show](util-methods.md#show): Remove `display: none;`
- [toggleShow](util-methods.md#toggleshow): Toggling show/hide element.
- [makeHiddenInput](util-methods.md#makehiddeninput): Make `input[type="hidden"]` element.
- [appendHiddenInput](util-methods.md#appendhiddeninput): Append hidden type input to target element.

## [Element Filter](element-filter.md)

Class for filtering elements.

## [Element Sorter](element-sorter.md)

Class for sort elements.
